///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGEnforceLinkPasswordPolicy;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `EnforceLinkPasswordPolicy` union.
///
/// Policy for deciding whether password must be enforced when an externally
/// shared link is updated
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGEnforceLinkPasswordPolicy : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMLOGEnforceLinkPasswordPolicyTag` enum type represents the
/// possible tag states with which the `DBTEAMLOGEnforceLinkPasswordPolicy`
/// union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMLOGEnforceLinkPasswordPolicyTag){
    /// (no description).
    DBTEAMLOGEnforceLinkPasswordPolicyOptional,

    /// (no description).
    DBTEAMLOGEnforceLinkPasswordPolicyRequired,

    /// (no description).
    DBTEAMLOGEnforceLinkPasswordPolicyOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMLOGEnforceLinkPasswordPolicyTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "optional".
///
/// @return An initialized instance.
///
- (instancetype)initWithOptional;

///
/// Initializes union class with tag state of "required".
///
/// @return An initialized instance.
///
- (instancetype)initWithRequired;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "optional".
///
/// @return Whether the union's current tag state has value "optional".
///
- (BOOL)isOptional;

///
/// Retrieves whether the union's current tag state has value "required".
///
/// @return Whether the union's current tag state has value "required".
///
- (BOOL)isRequired;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMLOGEnforceLinkPasswordPolicy` union.
///
@interface DBTEAMLOGEnforceLinkPasswordPolicySerializer : NSObject

///
/// Serializes `DBTEAMLOGEnforceLinkPasswordPolicy` instances.
///
/// @param instance An instance of the `DBTEAMLOGEnforceLinkPasswordPolicy` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGEnforceLinkPasswordPolicy` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGEnforceLinkPasswordPolicy *)instance;

///
/// Deserializes `DBTEAMLOGEnforceLinkPasswordPolicy` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGEnforceLinkPasswordPolicy` API object.
///
/// @return An instantiation of the `DBTEAMLOGEnforceLinkPasswordPolicy` object.
///
+ (DBTEAMLOGEnforceLinkPasswordPolicy *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
